<?php
/*  controller.php
 *
 *  part of phpMMVC 1.0 by Eric Newport aka Kethinov - http://eric.halo43.com
 *
 *  licensed under the Creative Commons Attribution 3.0 United States License.
 *  You are permitted to redistribute and/or modify this work for commercial or
 *  noncommercial purposes provided proper attribution to the original author (me)
 *  is present in the redistribution.
 */

// set settings here
$_CONTROLLER['MODELS_PATH'] = 'php/models/';
$_CONTROLLER['DEFAULT_PAGE'] = 'index.php';
$_CONTROLLER['404_PAGE'] = '404.php';

// define utility controller vars
$_CONTROLLER['BASE_DIR'] = dirname($_SERVER['PHP_SELF']);
$_CONTROLLER['PATH_ARGS'] = explode('/', $_SERVER['QUERY_STRING']);

// strip get args from first path arg
$getstart = strpos($_CONTROLLER['PATH_ARGS'][0], '&');
if ($getstart) $_CONTROLLER['PATH_ARGS'][0] = substr($_CONTROLLER['PATH_ARGS'][0], 0, $getstart);
unset($getstart);

// controller logic
if ($_CONTROLLER['PATH_ARGS'][0]) { // first argument must map directly to a model
	
	// extensionless request
	if (file_exists($_CONTROLLER['MODELS_PATH'].$_CONTROLLER['PATH_ARGS'][0].'.php')) {
		require_once($_CONTROLLER['MODELS_PATH'].$_CONTROLLER['PATH_ARGS'][0].'.php');
	}
	
	// request has a .php extension
	elseif (file_exists($_CONTROLLER['MODELS_PATH'].$_CONTROLLER['PATH_ARGS'][0]) && substr($_CONTROLLER['MODELS_PATH'].$_CONTROLLER['PATH_ARGS'][0], strlen($_CONTROLLER['MODELS_PATH'].$_CONTROLLER['PATH_ARGS'][0]), 4) == '.php') {
		require_once($_CONTROLLER['MODELS_PATH'].$_CONTROLLER['PATH_ARGS'][0]);
	}

	// file doesn't exist
	elseif (file_exists($_CONTROLLER['MODELS_PATH'].$_CONTROLLER['404_PAGE'])) {
		require_once($_CONTROLLER['MODELS_PATH'].$_CONTROLLER['404_PAGE']);
	}
	
	// 404 page doesn't exist
	else {
		?><!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html><head>
<title>404 Not Found</title>
</head><body>
<h1>Not Found</h1>
<p>The requested URL <?php echo $_SERVER['REQUEST_URI'] ?> was not found on this server.</p>
<hr>
<address><?php echo $_SERVER['SERVER_SOFTWARE'] ?> at <?php echo $_SERVER['SERVER_NAME'] ?> Port <?php echo $_SERVER['SERVER_PORT'] ?></address>
</body></html><?php
	}
}

// no first argument, send user directly to default page
elseif (file_exists($_CONTROLLER['MODELS_PATH'].$_CONTROLLER['DEFAULT_PAGE'])) {
	require_once($_CONTROLLER['MODELS_PATH'].$_CONTROLLER['DEFAULT_PAGE']);
}

// cannot find default page either, redirect to 404 page
elseif (file_exists($_CONTROLLER['MODELS_PATH'].$_CONTROLLER['404_PAGE'])) {
	require_once($_CONTROLLER['MODELS_PATH'].$_CONTROLLER['404_PAGE']);
}

// cannot find 404 page either
else {
	?><!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html><head>
<title>404 Not Found</title>
</head><body>
<h1>Not Found</h1>
<p>The requested URL <?php echo $_SERVER['REQUEST_URI'] ?> was not found on this server.</p>
<hr>
<address><?php echo $_SERVER['SERVER_SOFTWARE'] ?> at <?php echo $_SERVER['SERVER_NAME'] ?> Port <?php echo $_SERVER['SERVER_PORT'] ?></address>
</body></html><?php
}
?>